'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _resizeObserverPolyfill = require('resize-observer-polyfill');

var _resizeObserverPolyfill2 = _interopRequireDefault(_resizeObserverPolyfill);

var _scrollparent = require('scrollparent');

var _scrollparent2 = _interopRequireDefault(_scrollparent);

var _viewportScroll = require('./viewport-scroll');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Measure = function (_Component) {
  _inherits(Measure, _Component);

  function Measure() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Measure);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Measure.__proto__ || Object.getPrototypeOf(Measure)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      width: 0,
      height: 0,
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      scrollTop: 0,
      scrollLeft: 0,
      scrollWidth: 0,
      scrollHeight: 0
    }, _this.setMeasurements = function () {
      var rect = _this.node.getBoundingClientRect();
      _this.setState({
        width: rect.width,
        height: rect.height,
        top: rect.top,
        right: rect.right,
        bottom: rect.bottom,
        left: rect.left,
        scrollTop: _this.node.scrollTop,
        scrollLeft: _this.node.scrollLeft,
        scrollWidth: _this.node.scrollWidth,
        scrollHeight: _this.node.scrollHeight
      }, function () {
        _this.props.onMeasure(_this.state, _this.props.data);
      });
    }, _this.firstResizeEvent = true, _this.resizeObserver = new _resizeObserverPolyfill2.default(function () {
      console.log(_this.props.data, ' resized');
      if (_this.firstResizeEvent) {
        _this.firstResizeEvent = false;
      } else {
        _this.setMeasurements();
      }
    }), _this.setRef = function (node) {
      if (!_this.node && node) {
        _this.node = node;
        _this.setMeasurements();
        _this.resizeObserver.observe(node);
      }
    }, _this.cleanup = function () {
      _this.resizeObserver.unobserve(_this.node);
      _this.node = null;
    }, _this.handleScroll = function () {
      _this.isScrolling = false;
      _this.setState({
        scrollTop: _this.node.scrollTop,
        scrollLeft: _this.node.scrollLeft
      }, function () {
        _this.props.onScroll(_this.state);
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  // prevent firing two renders when component mounts
  // setRef is faster than attaching a resizeObserver and waiting for the first callback


  // handleScroll = () => {
  //   if (!this.isScrolling) {
  //     this.isScrolling = true
  //     requestAnimationFrame(this.updateScroll)
  //   }
  // }

  _createClass(Measure, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (!this.props.lockPosition) {
        (0, _viewportScroll.watchViewportScroll)(this.setMeasurements);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.cleanup();
      this.resizeObserver.disconnect();
      if (!this.props.lockPosition) {
        (0, _viewportScroll.unwatchViewportScroll)(this.setMeasurements);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children(_extends({
        bind: {
          ref: this.setRef,
          onScroll: this.handleScroll
        }
      }, this.state));
    }
  }]);

  return Measure;
}(_react.Component);

Measure.defaultProps = {
  data: null,
  lockPosition: false,
  onMeasure: function onMeasure() {
    return null;
  },
  onScroll: function onScroll() {
    return null;
  }
};
exports.default = Measure;