'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _viewportScroll = require('./viewport-scroll');

var _viewportResize = require('./viewport-resize');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getScrollParent() {
  return null;
}

var Viewport = function (_Component) {
  _inherits(Viewport, _Component);

  function Viewport() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Viewport);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Viewport.__proto__ || Object.getPrototypeOf(Viewport)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      width: 0,
      height: 0,
      scrollWidth: 0,
      scrollHeight: 0,
      scrollX: 0,
      scrollY: 0,
      scrollXDirection: null,
      scrollYDirection: null
    }, _this.handleScroll = function (event) {
      _this.setState(event);
      _this.props.onScroll(event);
    }, _this.handleResize = function (event) {
      _this.setState(event);
      _this.props.onResize(event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Viewport, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.monitorSize(this.props.resize);
      this.monitorScroll(this.props.scroll);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.resize !== nextProps.resize) {
        this.monitorSize(nextProps.resize);
      }
      if (this.props.scroll !== nextProps.scroll) {
        this.monitorScroll(nextProps.scroll);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.monitorSize(false);
      this.monitorScroll(false);
    }
  }, {
    key: 'monitorScroll',
    value: function monitorScroll(enable) {
      if (enable) {
        (0, _viewportScroll.watchViewportScroll)(this.handleScroll);
      } else {
        (0, _viewportScroll.unwatchViewportScroll)(this.handleScroll);
      }
    }
  }, {
    key: 'monitorSize',
    value: function monitorSize(enable) {
      if (enable) {
        (0, _viewportResize.watchViewportResize)(this.handleResize);
      } else {
        (0, _viewportResize.unwatchViewportResize)(this.handleResize);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children(this.state);
    }
  }]);

  return Viewport;
}(_react.Component);

Viewport.defaultProps = {
  resize: true,
  scroll: true,
  onScroll: function onScroll() {
    return null;
  },
  onResize: function onResize() {
    return null;
  }
};
exports.default = Viewport;